/*
   File Name:

      RayTracer.h

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This file is the header to the ray tracing functions used to create the scene.
*/


#ifndef RAY_TRACER_H
#define RAY_TRACER_H


#include"CVector.h"
#include"Ray.h"
#include"Light.h"
#include"Shape.h"

#define MAX_RECURSION   6


// Function prototypes...
CVector4* GenerateRayDirections(int width, int height, int depth);

void TraceScene(Shape *shapeList, int totalShapes, CLight *lights, int totalLights,
                Ray ray, float &r, float &g, float &b);

void LightShadeShape(Shape *shape, int shapeIndex, int totalShapes, Ray &ray,
                     float dist, CLight *lights, int totalLights,
                     float &r, float &g, float &b);

#endif


// Copyright February 2005
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com